#if !defined(AFX_HISTORYMGR_H__5282B398_6D22_11D4_B8C4_E7F534615240__INCLUDED_)
#define AFX_HISTORYMGR_H__5282B398_6D22_11D4_B8C4_E7F534615240__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// HistoryMgr.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CHistoryMgr window

class CHistoryMgr : public CStringArray
{
public:
	CHistoryMgr();
	virtual ~CHistoryMgr();

	//returns the new status
	int SetMaxItems ( int iMax = 20) {
		SetSize( iMax, 1);
		return iMaxItems = iMax;
	}
	BOOL Add( LPCTSTR lpszPath);
	BOOL Add( LPCTSTR lpszResourceName, LPCTSTR lpszResourceType);
	BOOL Add( UINT uID, LPCTSTR lpszResourceType) {
		return Add( MAKEINTRESOURCE(uID), lpszResourceType);
	}
	BOOL IsFile(int nIndex);
	BOOL IsEmpty(int nIndex);

	void RemoveAt(int nIndex); //removes an index
	void RemoveAt( LPCTSTR lpszPath); //removes a file name
	void RemoveAt( LPCTSTR lpszResourceName, LPCTSTR lpszResourceType); //removes a resource
	void RemoveAt( UINT uID, LPCTSTR lpszResourceType) {
		RemoveAt( MAKEINTRESOURCE(uID), lpszResourceType);
	}


	int GetCount();
	BOOL GetFile(int nIndex, CString &strFileName);
	BOOL GetResource(int nIndex, CString &strResourceName, CString &strResourceType);

	//returns a reference for your editing
	CStringArray& GetArray() { return *this; }

protected:
	static CString strFilePrefix;
	static CString strResourcePrefix;

	BOOL InsertToPlace( LPCTSTR  lpszFileName);
	int Find( LPCTSTR lpszFileName);
	void RemoveExtra();

	BOOL IsValid(int nIndex) {
		int iSize = GetSize();
		return ((nIndex<iSize) && (nIndex>=0));
	}

	void CreateFileString(CString &strOut, LPCTSTR lpszPath);
	void CreateResourceString(CString &strOut,  LPCTSTR lpszResourceName, LPCTSTR lpszResourceType);

protected:
	int iMaxItems;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HISTORYMGR_H__5282B398_6D22_11D4_B8C4_E7F534615240__INCLUDED_)
