#if !defined(AFX_PICTUREMGR_H__E9851EE1_67A4_11D4_B8C4_B89F557B3443__INCLUDED_)
#define AFX_PICTUREMGR_H__E9851EE1_67A4_11D4_B8C4_B89F557B3443__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PictureMgr.h : header file
//

#include "HistoryMgr.h"

/////////////////////////////////////////////////////////////////////////////
// CPictureMgr command target

class CPictureMgr : public CObject
{
public:
	CPictureMgr();           // protected constructor used by dynamic creation
	virtual ~CPictureMgr();

	CWnd* SetWindow( CWnd *pNewWnd, BOOL bWindowIsView = FALSE);

/*  You should consider placing you jpeg pictures under RT_HTML
	resource type . especially if you use html files to be loaded
	views or controls . You will be able to use your image in both
	(also linked to your html)  */
	BOOL LoadPicture( LPCTSTR lpszFileName);
	BOOL LoadFromResource( LPCTSTR lpResourceName, LPCTSTR lpResourceType = _T("JPEG"), BOOL bUseMemFile = TRUE);
	BOOL LoadFromResource( UINT uID, LPCTSTR lpResourceType = _T("JPEG"), BOOL bUseMemFile = TRUE) {
		return LoadFromResource( MAKEINTRESOURCE(uID), lpResourceType);
	}

	BOOL IsExistPicture() { return (m_pPicture != NULL); }
	BOOL GetType(short* ptype);
	BOOL GetAttributes(DWORD* pdwAttr);

	CSize GetPictureSize() { return m_sizeInPix; }
	CSize GetFileSize() { return m_sizeFileSize; }

	void OnDraw(CDC *pDC) {	InternalDraw(pDC); }
	void OnPaint(CDC *pDC) { InternalDraw(pDC); }

	 // CScrollView ONLY!!!
	void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo);
	
	 // CScrollView ONLY!!!
	BOOL OnEraseBkgnd(CDC *pDC);
	 // CScrollView ONLY!!!
	void OnUpdate( CView *pSender, LPARAM lHint, CObject *pHint);

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPictureMgr)
	//}}AFX_VIRTUAL

protected:
	void ResetContent();
	BOOL SetInfo(HRESULT hr);
	void InternalDraw(CDC *pDC);
	void Render( CDC *pDC, CSize size, CRect rect);

	BOOL LoadFromGlobal( HGLOBAL hGlobal);
	HGLOBAL GetGlobalFromResourceFunctions( LPCTSTR lpResourceName, LPCTSTR lpResourceType);
	HGLOBAL GetGlobalFromMemoryFile(LPCTSTR lpResourceName, LPCTSTR lpResourceType);

protected:
	CString strPictureFile;

	DWORD m_sizeFileSize; //size of the file or the resource of the current picture
	CSize m_sizeInPix;
	CSize m_sizeInHiMetric;
	IPicture *m_pPicture;
	CWnd *pWnd;

protected:
	BOOL bWindowIsView; //False = Control Such as static
};

//includes history support (use with views)
class CPictureMgrEx : public CPictureMgr
{
public:
	CPictureMgrEx();
	virtual ~CPictureMgrEx();

	void OnDropFiles(HDROP hDropInfo);
	//work directly with history object
	CHistoryMgr& GetHistory() { return m_HistoryMgr; }

protected:
	CHistoryMgr  m_HistoryMgr;
	
};





/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PICTUREMGR_H__E9851EE1_67A4_11D4_B8C4_B89F557B3443__INCLUDED_)
