#if !defined(AFX_STATICANIM_H__D2A9ED6F_2747_11D4_B8C4_C2AF600AE15E__INCLUDED_)
#define AFX_STATICANIM_H__D2A9ED6F_2747_11D4_B8C4_C2AF600AE15E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// StaticAnim.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CStaticAnim window

typedef int DIRECTION;

class CStaticAnim : public CStatic
{
public:
	CStaticAnim();
	~CStaticAnim();

	BOOL Pause();
	BOOL Play();
	int SetFrequency(int iNewFrequency = 60);
													// no link					//menu disabled				
	BOOL SubclassDlgItem( UINT nID, CWnd* pParent, LPCTSTR lpszLink = NULL, BOOL bEnableMenu = FALSE);

	BOOL SetBitmap( LPCTSTR lpszResourceName, int cx, int cy, BOOL bAdjustWindowSize = TRUE);
	BOOL SetBitmap( UINT nIDResource, int cx, int cy, BOOL bAdjustWindowSize = TRUE) {
		return SetBitmap( MAKEINTRESOURCE(nIDResource), cx, cy, bAdjustWindowSize);
	}

	void SetLink( LPCTSTR lpszLink = NULL);
	//returns the last (current) : gets TRUE as default 'cause
	//if you already call this function , you probably wants to enable
	//on start it's disabled
	BOOL EnableContextMenu( BOOL bEnable = TRUE) {
		return bEnableContextMenu = bEnable;
	}
	
	//Set your own menu as the menu that will be activated
	//as the context menu (previous menu will be destroyed : cant
	//take the chance you will have to do additional action: destroy it.
	//(thats why I dont return it)). second parameter tell whether to detach it
	//from your menu : prevent it from being deleted : from now on its
	// CStaticAnim responsibility to maintain menu .
	//NOTICE ! (an ownerdrawn menus with additional data pointer in MENUITEMINFO::dwItemData 
	//(created with new) are still not deleted . 
	BOOL SetMenu( CMenu &menu, BOOL bDetachOriginal = TRUE);

	//You should override this function in a derived class
	//if your class will enable context menu then you will be 
	//able to create your own menu and handlers.
	//this class includes default implementation (as example only)
	virtual void DoContextMenu(CWnd* pWnd, CPoint point);

protected:
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStaticAnim)
	protected:
	virtual void PreSubclassWindow();
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CStaticAnim)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	afx_msg void OnMenuCommand(UINT nID);
	DECLARE_MESSAGE_MAP()

protected:
	void AdjustSize( int cx, int cy, BOOL bAdjustWindowSize);
	BOOL bAdjustWindow2IconSize; //will adjust the size

	int  iFrequency;
	UINT uTimerID;
	BOOL bPlaying;

	BOOL Step(BOOL bMoveNext = FALSE);
	int GetPosition()  const {	return iPosition ; }
	int SetPosition(int iNewPosition);
	int iPosition;

	enum { UP = 1, DOWN = 2 };
	DIRECTION GetDirection() { return iDirection; }
	DIRECTION SetDirection( DIRECTION iNewDirection = UP);
	DIRECTION iDirection; //1=up 2=down

	CSize m_ImageSize, // size of each image 
			m_BitmapSize; // size of whole image 

	CMenu m_hMenu;//internal menu allows user interfase
	BOOL bEnableContextMenu;
	BOOL CreateMenu();

	int iImageCount;
	CBitmap  m_bitmap;
	CPalette  m_palette;

	/* the cursor is created whenever link is active : whenever its active
	if you press the control you'll navigate some place (like in
	(old) versions of internet explorer (netscape) you remove the link 
	by setting it to NULL , then these features are disabled and the cursor 
	returns to the previous arrow shape : look at SetLink(LPCTSTR) 	*/
	HCURSOR	g_hCursorHand; // this cursor is relevant when
	CString strLink;//context menu is enabled
	BOOL  bEnableLink;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STATICANIM_H__D2A9ED6F_2747_11D4_B8C4_C2AF600AE15E__INCLUDED_)
