// StaticLogo.cpp : implementation file
//

#include "stdafx.h"
#include "StaticLogo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStaticLogo
CStaticLogo::CStaticLogo( LPCTSTR lpszText)
{
	m_strText = lpszText;								// link text (NULL ==> window text)
	m_color = 0x9C000000|RGB(148,184,171);
}

UINT CStaticLogo::dwStyle = WS_CHILD|WS_VISIBLE|SS_NOTIFY;

BEGIN_MESSAGE_MAP(CStaticLogo, CStatic)
	//{{AFX_MSG_MAP(CStaticLogo)
	ON_WM_PAINT()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStaticLogo message handlers
//////////////////

BOOL CStaticLogo::SetLogoFont(CString lpszFaceName, int nHeight,
	int nWeight, BYTE bItalic, BYTE bUnderline)
{
	if (!m_font.GetSafeHandle())
		return m_font.CreateFont(nHeight, 0, 0, 0, nWeight, bItalic, bUnderline,0,0,0,0,0,0, lpszFaceName);
	return TRUE;
}

void CStaticLogo::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	if (m_strText.IsEmpty())
		return;

	CRect rectText;
	::GetWindowRect(m_hWnd,&rectText);
	ScreenToClient(&rectText);
	rectText += CPoint(1,1);

	if (!m_font.GetSafeHandle())   
			SetLogoFont(_T("Arial"));
	dc.SetBkMode(TRANSPARENT);
	CFont *OldFont = dc.SelectObject(&m_font);

	// draw text in DC
	COLORREF OldColor = dc.SetTextColor( ::GetSysColor( COLOR_3DHILIGHT));

	dc.DrawText( m_strText, &rectText, DT_SINGLELINE|DT_LEFT|DT_VCENTER);
	dc.SetTextColor( ::GetSysColor( COLOR_3DSHADOW));
	rectText-=CPoint(1,1);
	dc.DrawText( m_strText, &rectText, DT_SINGLELINE|DT_LEFT|DT_VCENTER);

	dc.SetTextColor(OldColor);// restore old text color
	dc.SelectObject(OldFont);// restore old font
}

///////////////////////////////////////////////////////
/////////// Creation (+destruction) functions
void CStaticLogo::PreSubclassWindow() 
{
	ModifyStyle( 0, dwStyle, 0);
	CStatic::PreSubclassWindow();
}
BOOL CStaticLogo::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style |= dwStyle;	
	return CStatic::PreCreateWindow(cs);
}

int CStaticLogo::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CStatic::OnCreate(lpCreateStruct) == -1)
		return -1;

	return 0;
}


